## postsrsd 1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4)
project(postsrsd C)
include(CheckIncludeFile)

option(GENERATE_SRS_SECRET "Generate a random SRS secret if none exists during install" ON)
option(USE_APPARMOR "Enable AppArmor profile" OFF)

set(CHROOT_DIR "${CMAKE_INSTALL_PREFIX}/lib/${PROJECT_NAME}" CACHE PATH "Chroot jail for daemon")
set(SYSCONF_DIR "/etc" CACHE PATH "Global system configuration folder")
set(CONFIG_DIR "${SYSCONF_DIR}/default" CACHE PATH "Location of startup configuration file")
set(DOC_DIR "share/doc/${PROJECT_NAME}" CACHE PATH "Path for documentation files")

find_program(HELP2MAN help2man DOC "path to help2man executable")
find_program(DD dd DOC "path to dd executable")
find_program(BASE64 base64 DOC "path to base64 executable")
find_program(INSSERV insserv DOC "path to insserv executable")
find_program(CHKCONFIG chkconfig DOC "path to chkconfig executable")

check_include_file(sys/wait.h HAVE_SYS_WAIT_H)
if(HAVE_SYS_WAIT_H)
    add_definitions(-DHAVE_SYS_WAIT_H)
endif()
check_include_file(wait.h HAVE_WAIT_H)
if(HAVE_WAIT_H)
    add_definitions(-DHAVE_WAIT_H)
endif()
check_include_file(sys/time.h HAVE_SYS_TIME_H)
if(HAVE_SYS_TIME_H)
    add_definitions(-DHAVE_SYS_TIME_H)
endif()
check_include_file(time.h HAVE_TIME_H)
if(HAVE_TIME_H)
    add_definitions(-DHAVE_TIME_H)
endif()

if(NOT DEFINED INIT_FLAVOR)
	if(IS_DIRECTORY "${SYSCONF_DIR}/systemd" AND EXISTS "/usr/lib/systemd/systemd")
        message(STATUS "Detected init flavor: systemd")
        set(INIT_FLAVOR "systemd" CACHE STRING "Init daemon of this system")
    elseif(IS_DIRECTORY "${SYSCONF_DIR}/init" AND EXISTS "/lib/init/upstart-job")
        message(STATUS "Detected init flavor: upstart")
        set(INIT_FLAVOR "upstart" CACHE STRING "Init daemon of this system")
    elseif(IS_DIRECTORY "${SYSCONF_DIR}/init.d" AND EXISTS "${SYSCONF_DIR}/init.d/functions")
        message(STATUS "Detected init flavor: sysv-redhat")
        set(INIT_FLAVOR "sysv-redhat" CACHE STRING "Init daemon of this system")
    elseif(IS_DIRECTORY "${SYSCONF_DIR}/init.d" AND EXISTS "/lib/lsb/init-functions")
        message(STATUS "Detected init flavor: sysv-lsb")
        set(INIT_FLAVOR "sysv-lsb" CACHE STRING "Init daemon of this system")
    else()
        message(STATUS "Detected init flavor: none")
        message(STATUS "System startup files will not be installed")
        set(INIT_FLAVOR "" CACHE STRING "Init daemon of this system")
    endif()
endif()

add_executable(${PROJECT_NAME} postsrsd.c sha1.c srs2.c)

get_target_property(POSTSRSD ${PROJECT_NAME} LOCATION)
get_filename_component(POSTSRSD ${POSTSRSD} NAME_WE)
set(APPARMOR_PROFILE "${CMAKE_INSTALL_PREFIX}/sbin/${POSTSRSD}")
string(REGEX REPLACE "^/+" "" APPARMOR_PROFILE "${APPARMOR_PROFILE}")
string(REPLACE "/" "." APPARMOR_PROFILE "${APPARMOR_PROFILE}")

configure_file(init/${PROJECT_NAME}.sysv-lsb.in ${PROJECT_NAME}.sysv-lsb @ONLY)
configure_file(init/${PROJECT_NAME}.sysv-redhat.in ${PROJECT_NAME}.sysv-redhat @ONLY)
configure_file(init/${PROJECT_NAME}.upstart.in ${PROJECT_NAME}.upstart @ONLY)
configure_file(init/${PROJECT_NAME}.apparmor.in ${PROJECT_NAME}.apparmor @ONLY)
configure_file(init/${PROJECT_NAME}.systemd.in ${PROJECT_NAME}.systemd @ONLY)
configure_file(init/${PROJECT_NAME}.default.in ${PROJECT_NAME}.default @ONLY)

configure_file(postinstall.cmake.in postinstall.cmake @ONLY)

if(HELP2MAN)
add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
	COMMAND ${HELP2MAN} ARGS -s8 -o${PROJECT_NAME}.8 -n "Postfix Sender Rewriting Scheme daemon" -N -h-h -v-v ${CMAKE_CURRENT_BINARY_DIR}/${POSTSRSD}
	VERBATIM
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.8 DESTINATION "share/man/man8")
endif()

if(USE_APPARMOR)
	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.apparmor DESTINATION "${SYSCONF_DIR}/apparmor.d" RENAME "${APPARMOR_PROFILE}")
endif()

install(TARGETS ${PROJECT_NAME} DESTINATION "sbin")
install(FILES README.md main.cf.ex DESTINATION "${DOC_DIR}")
install(SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/postinstall.cmake")

=== debian/changelog ===
postsrsd (1.2-1) unstable; urgency=medium

  * Initial release (Closes: #757720)

 -- Oxan van Leeuwen <oxan@oxanvanleeuwen.nl>  Fri, 26 Dec 2014 17:35:38 +0100

=== debian/control ===
Source: postsrsd
Section: mail
Priority: optional
Maintainer: Oxan van Leeuwen <oxan@oxanvanleeuwen.nl>
Build-Depends: debhelper (>= 9), cmake, dh-systemd, dh-apparmor, po-debconf
Standards-Version: 3.9.6
Homepage: https://github.com/roehling/postsrsd
Vcs-Git: git://anonscm.debian.org/collab-maint/postsrsd.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/postsrsd.git

Package: postsrsd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, debconf
Description: Sender Rewriting Scheme (SRS) lookup table for Postfix
 PostSRSd provides Sender Rewriting Scheme (SRS) support for Postfix via
 TCP-based lookup tables. SRS is needed if your mail server acts as a forwarder,
 and the mail originates from a server with Sender Policy Framework (SPF)
 enabled.

=== debian/rules ===
#!/usr/bin/make -f

# export build flags
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=cmake --with=systemd

override_dh_auto_configure:
	dh_auto_configure -O--buildsystem=cmake -- -DCMAKE_BUILD_TYPE=Release -DGENERATE_SRS_SECRET=OFF -DCHROOT_DIR=/var/lib/postsrsd -DUSE_APPARMOR=ON -DINIT_FLAVOR=

override_dh_install:
	dh_install
	dh_apparmor --profile-name=usr.sbin.postsrsd

override_dh_installinit:
	dh_installinit --restart-after-upgrade
	install -m 0644 obj-$(DEB_HOST_GNU_TYPE)/postsrsd.default debian/postsrsd/usr/share/postsrsd/postsrsd.template
	install -m 0755 obj-$(DEB_HOST_GNU_TYPE)/postsrsd.sysv-lsb debian/postsrsd/etc/init.d/postsrsd
	install -m 0644 obj-$(DEB_HOST_GNU_TYPE)/postsrsd.upstart debian/postsrsd/etc/init/postsrsd.conf

=== debian/watch ===
version=3
https://github.com/roehling/postsrsd/releases .*/(\d\S*)\.tar\.gz

## postsrsd 1.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,14 +7,27 @@
 
 set(CHROOT_DIR "${CMAKE_INSTALL_PREFIX}/lib/${PROJECT_NAME}" CACHE PATH "Chroot jail for daemon")
 set(SYSCONF_DIR "/etc" CACHE PATH "Global system configuration folder")
+set(SYSD_UNIT_DIR "${SYSCONF_DIR}/systemd/system" CACHE PATH "Systemd unit file folder")
 set(CONFIG_DIR "${SYSCONF_DIR}/default" CACHE PATH "Location of startup configuration file")
 set(DOC_DIR "share/doc/${PROJECT_NAME}" CACHE PATH "Path for documentation files")
+mark_as_advanced(CHROOT_DIR SYSCONF_DIR SYSD_UNIT_DIR CONFIG_DIR DOC_DIR)
 
 find_program(HELP2MAN help2man DOC "path to help2man executable")
 find_program(DD dd DOC "path to dd executable")
 find_program(BASE64 base64 DOC "path to base64 executable")
+find_program(OPENSSL openssl DOC "path to OpenSSL executable")
 find_program(INSSERV insserv DOC "path to insserv executable")
 find_program(CHKCONFIG chkconfig DOC "path to chkconfig executable")
+find_library(LIBSOCKET socket)
+find_library(LIBNSL nsl)
+
+if(BASE64)
+    set(BASE64_ENCODE "${BASE64}")
+elseif(OPENSSL)
+    set(BASE64_ENCODE "${OPENSSL} base64 -e")
+else()
+    set(BASE64_ENCODE "")
+endif()
 
 check_include_file(sys/wait.h HAVE_SYS_WAIT_H)
 if(HAVE_SYS_WAIT_H)
@@ -32,9 +45,17 @@
 if(HAVE_TIME_H)
     add_definitions(-DHAVE_TIME_H)
 endif()
+check_include_file(alloca.h HAVE_ALLOCA_H)
+if(HAVE_ALLOCA_H)
+    add_definitions(-DHAVE_ALLOCA_H)
+endif()
+check_include_file(sys/types.h HAVE_SYS_TYPES_H)
+if(HAVE_SYS_TYPES_H)
+    add_definitions(-DHAVE_SYS_TYPES_H)
+endif()
 
 if(NOT DEFINED INIT_FLAVOR)
-	if(IS_DIRECTORY "${SYSCONF_DIR}/systemd" AND EXISTS "/usr/lib/systemd/systemd")
+	if(IS_DIRECTORY "${SYSD_UNIT_DIR}" AND EXISTS "/usr/lib/systemd/systemd")
         message(STATUS "Detected init flavor: systemd")
         set(INIT_FLAVOR "systemd" CACHE STRING "Init daemon of this system")
     elseif(IS_DIRECTORY "${SYSCONF_DIR}/init" AND EXISTS "/lib/init/upstart-job")
@@ -54,6 +75,10 @@
 endif()
 
 add_executable(${PROJECT_NAME} postsrsd.c sha1.c srs2.c)
+
+if(${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
+    target_link_libraries(${PROJECT_NAME} ${LIBSOCKET} ${LIBNSL})
+endif()
 
 get_target_property(POSTSRSD ${PROJECT_NAME} LOCATION)
 get_filename_component(POSTSRSD ${POSTSRSD} NAME_WE)
@@ -83,6 +108,6 @@
 endif()
 
 install(TARGETS ${PROJECT_NAME} DESTINATION "sbin")
-install(FILES README.md main.cf.ex DESTINATION "${DOC_DIR}")
+install(FILES README.md README_UPGRADE.md main.cf.ex DESTINATION "${DOC_DIR}")
 install(SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/postinstall.cmake")

=== debian/changelog ===
postsrsd (1.4-1ubuntu0.1) bionic-security; urgency=medium

  * SECURITY UPDATE: Uncontrolled Resource Consumption
    - debian/patches/CVE-2020-35573.patch: SECURITY: Fix potential denial of
      service attack against PostSRSd.
    - CVE-2020-35573

 -- Paulo Flabiano Smorigo <pfsmorigo@canonical.com>  Fri, 05 Feb 2021 12:40:14 +0000

postsrsd (1.4-1) unstable; urgency=low

  [ Christian Perrier ]
  * Debconf templates and debian/control reviewed by the debian-l10n-
    english team as part of the Smith review project. Closes: #797861

  [ Debconf translation updates ]
  * Czech (Michal Simunek).  Closes: #801118
  * German (Chris Leick).  Closes: #801149
  * French (Julien Patriarca).  Closes: #801179
  * Brazilian Portuguese (Adriano Rafael Gomes).  Closes: #801188
  * Russian (Yuri Kozlov).  Closes: #801619
  * Spanish (Camaleón).  Closes: #801685
  * Dutch (Frans Spiesschaert).  Closes: #801705
  * Portuguese (Américo Monteiro).  Closes: #801824
  * Polish (Łukasz Dulny).  Closes: #801620
  * Italian (Beatrice Torracca).  Closes: #801874
  * Danish (Joe Hansen).  Closes: #801890

  [ Oxan van Leeuwen ]
  * New upstream release (Closes: #849307)
  * Run under postsrsd user by default instead of nobody (Closes: #801916)
  * Enable PIE and bindnow hardening options
  * Don't overwrite SRS_DOMAIN setting when manually changed by user

  [ Tomasz Buchert ]
  * Bumped Standards-Version to 3.9.8
  * Update to debhelper compat level 10 and drop dh-systemd dependency
  * Use version 4 watch file

 -- Oxan van Leeuwen <oxan@oxanvanleeuwen.nl>  Thu, 19 Jan 2017 15:07:09 +0100

=== debian/control ===
Source: postsrsd
Section: mail
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Oxan van Leeuwen <oxan@oxanvanleeuwen.nl>
Build-Depends: cmake, debhelper (>= 10), dh-apparmor, po-debconf
Standards-Version: 3.9.8
Homepage: https://github.com/roehling/postsrsd
Vcs-Git: https://anonscm.debian.org/git/collab-maint/postsrsd.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/postsrsd.git

Package: postsrsd
Architecture: any
Depends: adduser, debconf, lsb-base (>= 3.0-6), ${misc:Depends}, ${shlibs:Depends}
Description: Sender Rewriting Scheme (SRS) lookup table for Postfix
 PostSRSd provides Sender Rewriting Scheme (SRS) support for Postfix via
 TCP-based lookup tables. SRS is needed if your mail server acts as a forwarder,
 and the mail originates from a server with Sender Policy Framework (SPF)
 enabled.

=== debian/rules ===
#!/usr/bin/make -f

# export build flags
DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -O--buildsystem=cmake -- -DCMAKE_BUILD_TYPE=Release -DGENERATE_SRS_SECRET=OFF -DCHROOT_DIR=/var/lib/postsrsd -DUSE_APPARMOR=ON -DINIT_FLAVOR=

override_dh_install:
	dh_install
	dh_apparmor --profile-name=usr.sbin.postsrsd
	install -m 0644 obj-$(DEB_HOST_GNU_TYPE)/postsrsd.systemd debian/postsrsd/lib/systemd/system/postsrsd.service
	install -m 0644 obj-$(DEB_HOST_GNU_TYPE)/postsrsd.default debian/postsrsd/usr/share/postsrsd/postsrsd.template
	install -m 0755 obj-$(DEB_HOST_GNU_TYPE)/postsrsd.sysv-lsb debian/postsrsd/etc/init.d/postsrsd
	install -m 0644 obj-$(DEB_HOST_GNU_TYPE)/postsrsd.upstart debian/postsrsd/etc/init/postsrsd.conf

override_dh_installinit:
	dh_installinit --restart-after-upgrade --onlyscripts

## postsrsd 1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,15 @@
 cmake_minimum_required(VERSION 2.4)
+if(COMMAND cmake_policy)
+    if(POLICY CMP0026)
+        cmake_policy(SET CMP0026 OLD)
+    endif()
+endif()
 project(postsrsd C)
 include(CheckIncludeFile)
 
 option(GENERATE_SRS_SECRET "Generate a random SRS secret if none exists during install" ON)
 option(USE_APPARMOR "Enable AppArmor profile" OFF)
+option(USE_SELINUX "Enable SELinux policy module" OFF)
 
 set(CHROOT_DIR "${CMAKE_INSTALL_PREFIX}/lib/${PROJECT_NAME}" CACHE PATH "Chroot jail for daemon")
 set(SYSCONF_DIR "/etc" CACHE PATH "Global system configuration folder")
@@ -75,9 +81,13 @@
 endif()
 
 add_executable(${PROJECT_NAME} postsrsd.c sha1.c srs2.c)
+enable_testing()
+add_executable(${PROJECT_NAME}_tests tests.c sha1.c srs2.c)
+add_test(AllTests ${PROJECT_NAME}_tests)
 
 if(${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
     target_link_libraries(${PROJECT_NAME} ${LIBSOCKET} ${LIBNSL})
+    target_link_libraries(${PROJECT_NAME}_tests ${LIBSOCKET} ${LIBNSL})
 endif()
 
 get_target_property(POSTSRSD ${PROJECT_NAME} LOCATION)
@@ -107,6 +117,15 @@
 	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.apparmor DESTINATION "${SYSCONF_DIR}/apparmor.d" RENAME "${APPARMOR_PROFILE}")
 endif()
 
+if(USE_SELINUX)
+	file(COPY selinux/${PROJECT_NAME}.te selinux/${PROJECT_NAME}.fc DESTINATION selinux)
+	add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
+		WORKING_DIRECTORY selinux
+		COMMAND make -f /usr/share/selinux/devel/Makefile)
+	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/selinux/${PROJECT_NAME}.pp
+		DESTINATION /usr/share/selinux/packages/${PROJECT_NAME})
+endif()
+
 install(TARGETS ${PROJECT_NAME} DESTINATION "sbin")
 install(FILES README.md README_UPGRADE.md main.cf.ex DESTINATION "${DOC_DIR}")
 install(SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/postinstall.cmake")

=== debian/changelog ===
postsrsd (1.5-2) unstable; urgency=medium

  * Increase hashlength for unit tests (cherry-picked from upstream db9ed58)
  * Fix SHA-1 implementation on big endian architectures (cherry-picked from
    upstream 0b8f8be, Closes: #921189)

 -- Oxan van Leeuwen <oxan@oxanvanleeuwen.nl>  Sat, 23 Feb 2019 14:27:44 +0100

postsrsd (1.5-1) unstable; urgency=medium

  [ Tomasz Buchert ]
  * Update Standards-Version to 4.3.0
  * Update to debhelper compat level 12
  * Update Vcs-* fields to salsa

  [ Oxan van Leeuwen ]
  * New upstream release
  * Add 'm' permission to apparmor profile (Closes: #915118)

 -- Oxan van Leeuwen <oxan@oxanvanleeuwen.nl>  Sat, 19 Jan 2019 01:53:50 +0100

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,6 @@
 	install -m 0644 obj-$(DEB_HOST_GNU_TYPE)/postsrsd.systemd debian/postsrsd/lib/systemd/system/postsrsd.service
 	install -m 0644 obj-$(DEB_HOST_GNU_TYPE)/postsrsd.default debian/postsrsd/usr/share/postsrsd/postsrsd.template
 	install -m 0755 obj-$(DEB_HOST_GNU_TYPE)/postsrsd.sysv-lsb debian/postsrsd/etc/init.d/postsrsd
-	install -m 0644 obj-$(DEB_HOST_GNU_TYPE)/postsrsd.upstart debian/postsrsd/etc/init/postsrsd.conf
 
 override_dh_installinit:
-	dh_installinit --restart-after-upgrade --onlyscripts
+	dh_installinit --restart-after-upgrade --only-scripts

## postsrsd 1.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,8 @@
 cmake_minimum_required(VERSION 2.4)
-if(COMMAND cmake_policy)
-    if(POLICY CMP0026)
-        cmake_policy(SET CMP0026 OLD)
-    endif()
-endif()
 project(postsrsd C)
 include(CheckIncludeFile)
+include(CheckTypeSize)
+include(TestBigEndian)
 
 option(GENERATE_SRS_SECRET "Generate a random SRS secret if none exists during install" ON)
 option(USE_APPARMOR "Enable AppArmor profile" OFF)
@@ -24,6 +21,7 @@
 find_program(OPENSSL openssl DOC "path to OpenSSL executable")
 find_program(INSSERV insserv DOC "path to insserv executable")
 find_program(CHKCONFIG chkconfig DOC "path to chkconfig executable")
+find_program(SYSTEMD systemd)
 find_library(LIBSOCKET socket)
 find_library(LIBNSL nsl)
 
@@ -60,8 +58,15 @@
     add_definitions(-DHAVE_SYS_TYPES_H)
 endif()
 
+test_big_endian(WORDS_BIGENDIAN)
+if(WORDS_BIGENDIAN)
+    add_definitions(-DWORDS_BIGENDIAN)
+endif()
+check_type_size("unsigned long" SIZEOF_UNSIGNED_LONG)
+add_definitions(-DSIZEOF_UNSIGNED_LONG=${SIZEOF_UNSIGNED_LONG})
+
 if(NOT DEFINED INIT_FLAVOR)
-	if(IS_DIRECTORY "${SYSD_UNIT_DIR}" AND EXISTS "/usr/lib/systemd/systemd")
+    if(SYSTEMD)
         message(STATUS "Detected init flavor: systemd")
         set(INIT_FLAVOR "systemd" CACHE STRING "Init daemon of this system")
     elseif(IS_DIRECTORY "${SYSCONF_DIR}/init" AND EXISTS "/lib/init/upstart-job")
@@ -89,9 +94,7 @@
     target_link_libraries(${PROJECT_NAME} ${LIBSOCKET} ${LIBNSL})
     target_link_libraries(${PROJECT_NAME}_tests ${LIBSOCKET} ${LIBNSL})
 endif()
-
-get_target_property(POSTSRSD ${PROJECT_NAME} LOCATION)
-get_filename_component(POSTSRSD ${POSTSRSD} NAME_WE)
+set(POSTSRSD "${PROJECT_NAME}${CMAKE_EXECUTABLE_SUFFIX}")
 set(APPARMOR_PROFILE "${CMAKE_INSTALL_PREFIX}/sbin/${POSTSRSD}")
 string(REGEX REPLACE "^/+" "" APPARMOR_PROFILE "${APPARMOR_PROFILE}")
 string(REPLACE "/" "." APPARMOR_PROFILE "${APPARMOR_PROFILE}")

=== debian/changelog ===
postsrsd (1.6-1) unstable; urgency=medium

  * New upstream release
  * Update Standards-Version to 4.5.0 (no changes required)
  * Add Rules-Requires-Root: no
  * Fix init script to properly stop with dpkg >= 1.19.3 (cherry-pick upstream
    02efc02)

 -- Oxan van Leeuwen <oxan@oxanvanleeuwen.nl>  Fri, 17 Apr 2020 13:36:33 +0200

=== debian/control ===
Source: postsrsd
Maintainer: Oxan van Leeuwen <oxan@oxanvanleeuwen.nl>
Section: mail
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               dh-apparmor,
               po-debconf
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/postsrsd
Vcs-Git: https://salsa.debian.org/debian/postsrsd.git
Homepage: https://github.com/roehling/postsrsd

Package: postsrsd
Architecture: any
Depends: adduser, debconf, lsb-base (>= 3.0-6), ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Sender Rewriting Scheme (SRS) lookup table for Postfix
 PostSRSd provides Sender Rewriting Scheme (SRS) support for Postfix via
 TCP-based lookup tables. SRS is needed if your mail server acts as a forwarder,
 and the mail originates from a server with Sender Policy Framework (SPF)
 enabled.

## postsrsd 1.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,9 @@
-cmake_minimum_required(VERSION 2.4)
-project(postsrsd C)
+cmake_minimum_required(VERSION 3.0)
+project(postsrsd VERSION 1.10 LANGUAGES C)
 include(CheckIncludeFile)
 include(CheckTypeSize)
 include(TestBigEndian)
+include(CTest)
 
 option(GENERATE_SRS_SECRET "Generate a random SRS secret if none exists during install" ON)
 option(USE_APPARMOR "Enable AppArmor profile" OFF)
@@ -21,9 +22,12 @@
 find_program(OPENSSL openssl DOC "path to OpenSSL executable")
 find_program(INSSERV insserv DOC "path to insserv executable")
 find_program(CHKCONFIG chkconfig DOC "path to chkconfig executable")
-find_program(SYSTEMD systemd)
-find_library(LIBSOCKET socket)
-find_library(LIBNSL nsl)
+find_program(SYSTEMCTL systemctl DOC "path to systemctl executable")
+
+if(CMAKE_SYSTEM_NAME MATCHES "SunOS")
+    find_library(LIBSOCKET socket)
+    find_library(LIBNSL nsl)
+endif()
 
 if(BASE64)
     set(BASE64_ENCODE "${BASE64}")
@@ -66,12 +70,9 @@
 add_definitions(-DSIZEOF_UNSIGNED_LONG=${SIZEOF_UNSIGNED_LONG})
 
 if(NOT DEFINED INIT_FLAVOR)
-    if(SYSTEMD)
+    if(SYSTEMCTL)
         message(STATUS "Detected init flavor: systemd")
         set(INIT_FLAVOR "systemd" CACHE STRING "Init daemon of this system")
-    elseif(IS_DIRECTORY "${SYSCONF_DIR}/init" AND EXISTS "/lib/init/upstart-job")
-        message(STATUS "Detected init flavor: upstart")
-        set(INIT_FLAVOR "upstart" CACHE STRING "Init daemon of this system")
     elseif(IS_DIRECTORY "${SYSCONF_DIR}/init.d" AND EXISTS "${SYSCONF_DIR}/init.d/functions")
         message(STATUS "Detected init flavor: sysv-redhat")
         set(INIT_FLAVOR "sysv-redhat" CACHE STRING "Init daemon of this system")
@@ -85,15 +86,14 @@
     endif()
 endif()
 
+add_definitions(-DPOSTSRSD_VERSION=\"${PROJECT_VERSION}\")
 add_executable(${PROJECT_NAME} postsrsd.c sha1.c srs2.c)
-enable_testing()
-add_executable(${PROJECT_NAME}_tests tests.c sha1.c srs2.c)
-add_test(AllTests ${PROJECT_NAME}_tests)
 
-if(${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
+if(CMAKE_SYSTEM_NAME MATCHES "SunOS")
     target_link_libraries(${PROJECT_NAME} ${LIBSOCKET} ${LIBNSL})
     target_link_libraries(${PROJECT_NAME}_tests ${LIBSOCKET} ${LIBNSL})
 endif()
+
 set(POSTSRSD "${PROJECT_NAME}${CMAKE_EXECUTABLE_SUFFIX}")
 set(APPARMOR_PROFILE "${CMAKE_INSTALL_PREFIX}/sbin/${POSTSRSD}")
 string(REGEX REPLACE "^/+" "" APPARMOR_PROFILE "${APPARMOR_PROFILE}")
@@ -101,12 +101,17 @@
 
 configure_file(init/${PROJECT_NAME}.sysv-lsb.in ${PROJECT_NAME}.sysv-lsb @ONLY)
 configure_file(init/${PROJECT_NAME}.sysv-redhat.in ${PROJECT_NAME}.sysv-redhat @ONLY)
-configure_file(init/${PROJECT_NAME}.upstart.in ${PROJECT_NAME}.upstart @ONLY)
 configure_file(init/${PROJECT_NAME}.apparmor.in ${PROJECT_NAME}.apparmor @ONLY)
 configure_file(init/${PROJECT_NAME}.systemd.in ${PROJECT_NAME}.systemd @ONLY)
 configure_file(init/${PROJECT_NAME}.default.in ${PROJECT_NAME}.default @ONLY)
+configure_file(init/${PROJECT_NAME}-systemd-launcher.in ${PROJECT_NAME}-systemd-launcher @ONLY)
 
 configure_file(postinstall.cmake.in postinstall.cmake @ONLY)
+
+if(BUILD_TESTING)
+    add_executable(${PROJECT_NAME}_tests tests.c sha1.c srs2.c)
+    add_test(NAME AllTests COMMAND ${PROJECT_NAME}_tests)
+endif()
 
 if(HELP2MAN)
 add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
@@ -130,6 +135,6 @@
 endif()
 
 install(TARGETS ${PROJECT_NAME} DESTINATION "sbin")
+install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-systemd-launcher DESTINATION "share/${PROJECT_NAME}")
 install(FILES README.md README_UPGRADE.md main.cf.ex DESTINATION "${DOC_DIR}")
 install(SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/postinstall.cmake")
-

=== debian/changelog ===
postsrsd (1.10-2) unstable; urgency=medium

  * Fix CVE-2021-35525: potential DoS when Postfix sends certain long data
    fields such as multiple concatenated email addresses. Fix backported from
    upstream commit 077be98d8c8. (Closes: #990439)

 -- Oxan van Leeuwen <oxan@oxanvanleeuwen.nl>  Wed, 14 Jul 2021 21:21:11 +0200

postsrsd (1.10-1) unstable; urgency=medium

  * New upstream release (Closes: #975633)
  * Drop patches integrated upstream
  * Run upstream blackbox test during build
  * Add autopkgtest for a roundtrip rewrite
  * Don't write an empty SRS_DOMAIN setting if no value is provided by the user
  * Don't replace entered domain with default if preconfiguration is used
  * Update to debhelper compat level 13
  * Update Standards-Version to 4.5.1 (no changes required)

 -- Oxan van Leeuwen <oxan@oxanvanleeuwen.nl>  Wed, 02 Dec 2020 22:36:36 +0100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,13 @@
 Maintainer: Oxan van Leeuwen <oxan@oxanvanleeuwen.nl>
 Section: mail
 Priority: optional
-Build-Depends: cmake,
-               debhelper-compat (= 12),
+Build-Depends: bats,
+               cmake,
+               debhelper-compat (= 13),
                dh-apparmor,
+               faketime,
                po-debconf
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/postsrsd
 Vcs-Git: https://salsa.debian.org/debian/postsrsd.git

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,11 @@
 	dh $@ --buildsystem=cmake
 
 override_dh_auto_configure:
-	dh_auto_configure -O--buildsystem=cmake -- -DCMAKE_BUILD_TYPE=Release -DGENERATE_SRS_SECRET=OFF -DCHROOT_DIR=/var/lib/postsrsd -DUSE_APPARMOR=ON -DINIT_FLAVOR=
+	dh_auto_configure --buildsystem=cmake -- -DCMAKE_BUILD_TYPE=Release -DGENERATE_SRS_SECRET=OFF -DCHROOT_DIR=/var/lib/postsrsd -DUSE_APPARMOR=ON -DINIT_FLAVOR=
+
+override_dh_auto_test:
+	dh_auto_test --buildsystem=cmake
+	bats run_postsrsd_tests.bats
 
 override_dh_install:
 	dh_install

=== debian/tests/control ===
Tests: rewrite
Restrictions: isolation-container
# Install postfix to get postconf, so that there's a domain setting even if the debconf configuration is skipped.
Depends: @, postfix, bash

## postsrsd 2.0.11

=== CMakeLists.txt ===
# PostSRSd - Sender Rewriting Scheme daemon for Postfix
# Copyright 2012-2023 Timo Röhling <timo@gaussglocke.de>
# SPDX-License-Identifier: GPL-3.0-only
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
cmake_minimum_required(VERSION 3.14...3.29)
project(
    postsrsd
    VERSION 2.0.11
    LANGUAGES C
    DESCRIPTION "Sender Rewriting Scheme daemon for Postfix"
    HOMEPAGE_URL "https://github.com/roehling/postsrsd"
)

if(CMAKE_VERSION VERSION_LESS 3.21.0)
    # Workaround for https://gitlab.kitware.com/cmake/cmake/-/issues/22234
    if(POLICY CMP0082)
        cmake_policy(SET CMP0082 OLD)
    endif()
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(utils)
include(CTest)
include(FeatureSummary)
include(FetchContent)
include(GNUInstallDirs)
include(CheckIncludeFile)
include(CheckTypeSize)
include(CheckSymbolExists)
include(TestBigEndian)

set(POSTSRSD_CONFIGDIR
    "${CMAKE_INSTALL_FULL_SYSCONFDIR}"
    CACHE
        PATH
        "The default directory where PostSRSd should look for configuration files"
)
set(POSTSRSD_DATADIR
    "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/${PROJECT_NAME}"
    CACHE PATH "The default directory where PostSRSd should put runtime data"
)
set(POSTSRSD_CHROOTDIR
    "${POSTSRSD_DATADIR}"
    CACHE PATH "The default chroot directory where PostSRSd should jail itself"
)
set(POSTSRSD_USER
    "nobody"
    CACHE STRING "The default unprivileged user as which PostSRSd will run"
)

option(WITH_MILTER "Enable SRS rewrite via Milter (requires libmilter)" OFF)
add_feature_info(WITH_MILTER WITH_MILTER "run PostSRSd as milter")
option(WITH_SQLITE
       "Enable sqlite-based storage for opaque SRS tokens (requires sqlite3)"
       OFF
)
add_feature_info(WITH_SQLITE WITH_SQLITE "use SQLite as database backend")
option(WITH_REDIS
       "Enable Redis-based storage for opaque SRS tokens (requires hiredis)"
       OFF
)
add_feature_info(WITH_REDIS WITH_REDIS "use Redis as database backend")
option(TESTS_WITH_ASAN "Run test suite with AddressSanitizer" ON)
option(DEVELOPER_BUILD "Add strict compiler options for development only" OFF)
option(GENERATE_SRS_SECRET "Generate and install a postsrsd.secret" ON)
add_feature_info(
    GENERATE_SRS_SECRET
    GENERATE_SRS_SECRET
    "generate missing ${CMAKE_INSTALL_FULL_SYSCONFDIR}/${PROJECT_NAME}.secret on install"
)
option(INSTALL_SYSTEMD_SERVICE "Install the systemd postsrsd.service unit" ON)
add_feature_info(
    INSTALL_SYSTEMD_SERVICE INSTALL_SYSTEMD_SERVICE
    "install the systemd postsrsd.service unit"
)
find_systemd_unit_destination(DETECTED_SYSTEMD_UNITDIR)
set(SYSTEMD_UNITDIR
    "${DETECTED_SYSTEMD_UNITDIR}"
    CACHE PATH "Install destination for the systemd postsrsd.service unit"
)
find_systemd_sysusers_destination(DETECTED_SYSTEMD_SYSUSERSDIR)
set(SYSTEMD_SYSUSERSDIR
    "${DETECTED_SYSTEMD_SYSUSERSDIR}"
    CACHE PATH "Install destination for the sysusers.d configuration"
)

if(POSTSRSD_CHROOTDIR)
    file(RELATIVE_PATH CHROOTABLE_DATADIR "${POSTSRSD_CHROOTDIR}"
         "${POSTSRSD_DATADIR}"
    )
    if(CHROOTABLE_DATADIR MATCHES "^\.\.")
        message(
            FATAL_ERROR
                "POSTSRSD_DATADIR (${POSTSRSD_DATADIR}) must be below POSTSRSD_CHROOTDIR (${POSTSRSD_CHROOTDIR})"
        )
    endif()
    if(CHROOTABLE_DATADIR STREQUAL "")
        set(CHROOTABLE_DATADIR ".")
    endif()
else()
    set(CHROOTABLE_DATADIR "${POSTSRSD_DATADIR}")
endif()

mark_as_advanced(
    TESTS_WITH_ASAN
    GENERATE_SRS_SECRET
    DEVELOPER_BUILD
    SYSTEMD_UNITDIR
    POSTSRSD_CONFIGDIR
    POSTSRSD_CHROOTDIR
    POSTSRSD_DATADIR
    POSTSRSD_USER
)

FetchContent_Declare(
    Confuse
    URL https://github.com/libconfuse/libconfuse/releases/download/v3.3/confuse-3.3.tar.gz
    URL_HASH
        SHA3_256=da895d91a7755941872e73ff6522fd16810f1599862990df569459a0eee94515
)

FetchContent_Declare(
    Hiredis
    GIT_REPOSITORY https://github.com/redis/hiredis
    GIT_TAG c14775b4e48334e0262c9f168887578f4a368b5d
)

FetchContent_Declare(
    LibMilter
    GIT_REPOSITORY https://github.com/roehling/libmilter
    GIT_TAG 3661f3c5ac5e47205f26775031d2ac276d6d47ca
)

FetchContent_Declare(
    sqlite3
    URL https://sqlite.org/2023/sqlite-amalgamation-3410200.zip
    URL_HASH
        SHA3_256=c51ca72411b8453c64e0980be23bc9b9530bdc3ec1513e06fbf022ed0fd02463
)

FetchContent_Declare(
    Check
    URL https://github.com/libcheck/check/releases/download/0.15.2/check-0.15.2.tar.gz
    URL_HASH
        SHA3_256=bfb856a68c0ea4d930803f6bd16c1eed38910a231c9e0f0009e69310e35e7a5d
)

set(saved_CMAKE_REQUIRED_DEFINITIONS "${CMAKE_REQUIRED_DEFINITIONS}")
list(APPEND CMAKE_REQUIRED_DEFINITIONS "-D_GNU_SOURCE" "-D_FILE_OFFSET_BITS=64")

check_include_file(alloca.h HAVE_ALLOCA_H)
check_include_file(errno.h HAVE_ERRNO_H)
check_include_file(fcntl.h HAVE_FCNTL_H)
check_include_file(grp.h HAVE_GRP_H)
check_include_file(netdb.h HAVE_NETDB_H)
check_include_file(poll.h HAVE_POLL_H)
check_include_file(pwd.h HAVE_PWD_H)
check_include_file(signal.h HAVE_SIGNAL_H)
check_include_file(sys/file.h HAVE_SYS_FILE_H)
check_include_file(sys/inotify.h HAVE_SYS_INOTIFY_H)
check_include_file(sys/socket.h HAVE_SYS_SOCKET_H)
check_include_file(sys/stat.h HAVE_SYS_STAT_H)
check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(sys/un.h HAVE_SYS_UN_H)
check_include_file(sys/wait.h HAVE_SYS_WAIT_H)
check_include_file(syslog.h HAVE_SYSLOG_H)
check_include_file(time.h HAVE_TIME_H)
check_include_file(unistd.h HAVE_UNISTD_H)
check_symbol_exists(chroot unistd.h HAVE_CHROOT)
check_symbol_exists(close_range unistd.h HAVE_CLOSE_RANGE)
check_symbol_exists(setgroups grp.h HAVE_SETGROUPS)
check_symbol_exists(strcasecmp strings.h HAVE_STRCASECMP)
check_symbol_exists(_stricmp string.h HAVE__STRICMP)
check_symbol_exists(strncasecmp strings.h HAVE_STRNCASECMP)
check_symbol_exists(_strnicmp string.h HAVE__STRNICMP)
check_type_size("unsigned long" SIZEOF_UNSIGNED_LONG)
test_big_endian(HAVE_BIG_ENDIAN)

set(CMAKE_REQUIRED_DEFINITIONS "${saved_CMAKE_REQUIRED_DEFINITIONS}")

if(CMAKE_SYSTEM_NAME MATCHES "Solaris|SunOS")
    find_library(LIBSOCKET socket)
    find_library(LIBNSL nsl)
endif()

set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_package(Threads QUIET)

add_autotools_dependency(
    Confuse
    LIBRARY_NAME confuse
    EXPORTED_TARGET Confuse::Confuse
)

if(WITH_REDIS)
    set(DISABLE_TESTS
        ON
        CACHE BOOL "" FORCE
    )
    set(BUILD_SHARED_LIBS
        OFF
        CACHE BOOL "" FORCE
    )
    FetchContent_MakeAvailable(Hiredis)
    if(IS_DIRECTORY "${hiredis_SOURCE_DIR}")
        set_property(
            DIRECTORY "${hiredis_SOURCE_DIR}" PROPERTY EXCLUDE_FROM_ALL TRUE
        )
    endif()
    if(TARGET hiredis::hiredis_static)
        set(HIREDIS_TARGET hiredis::hiredis_static)
    elseif(TARGET hiredis::hiredis)
        set(HIREDIS_TARGET hiredis::hiredis)
    elseif(TARGET hiredis)
        set(HIREDIS_TARGET hiredis)
    else()
        message(
            FATAL_ERROR
                "Cannot link against hiredis: no suitable CMake target found"
        )
    endif()
endif()

if(WITH_MILTER)
    FetchContent_MakeAvailable(LibMilter)
    if(IS_DIRECTORY "${libmilter_SOURCE_DIR}")
        string(TOLOWER "${CMAKE_SYSTEM_NAME}" lc_system)
        set(SM_OS_H
            "${libmilter_SOURCE_DIR}/include/sm/os/sm_os_${lc_system}.h"
        )
        if(EXISTS "${SM_OS_H}")
            execute_process(
                COMMAND "${CMAKE_COMMAND}" -E copy_if_different "${SM_OS_H}"
                        "${libmilter_SOURCE_DIR}/include/sm/sm_os.h"
            )
            add_library(
                milter STATIC
                "${libmilter_SOURCE_DIR}/errstring.c"
                "${libmilter_SOURCE_DIR}/strl.c"
                "${libmilter_SOURCE_DIR}/comm.c"
                "${libmilter_SOURCE_DIR}/engine.c"
                "${libmilter_SOURCE_DIR}/handler.c"
                "${libmilter_SOURCE_DIR}/listener.c"
                "${libmilter_SOURCE_DIR}/main.c"
                "${libmilter_SOURCE_DIR}/monitor.c"
                "${libmilter_SOURCE_DIR}/signal.c"
                "${libmilter_SOURCE_DIR}/smfi.c"
                "${libmilter_SOURCE_DIR}/sm_gethost.c"
                "${libmilter_SOURCE_DIR}/worker.c"
            )
            target_compile_definitions(
                milter PRIVATE NOT_SENDMAIL=1 sm_snprintf=snprintf
            )
            target_include_directories(
                milter
                PRIVATE "${libmilter_SOURCE_DIR}/smapp"
                PUBLIC "${libmilter_SOURCE_DIR}/include"
                INTERFACE "${libmilter_SOURCE_DIR}/include/libmilter"
            )
            if(TARGET Threads::Threads)
                target_link_libraries(milter PRIVATE Threads::Threads)
            endif()
            add_library(LibMilter::LibMilter ALIAS milter)
        else()
            message(
                FATAL_ERROR
                    "Missing support for ${CMAKE_SYSTEM_NAME} for LibMilter"
            )
        endif()
    endif()
endif()

if(WITH_SQLITE)
    FetchContent_MakeAvailable(sqlite3)
    if(IS_DIRECTORY "${sqlite3_SOURCE_DIR}")
        add_library(sqlite3 STATIC "${sqlite3_SOURCE_DIR}/sqlite3.c")
        target_include_directories(sqlite3 PUBLIC "${sqlite3_SOURCE_DIR}")
        target_compile_definitions(
            sqlite3
            PRIVATE SQLITE_DQS=0
                    SQLITE_THREADSAFE=$<IF:$<BOOL:${WITH_MILTER}>,2,0>
                    SQLITE_DEFAULT_MEMSTATUS=0
                    SQLITE_DEFAULT_WAL_SYNCHRONOUS=1
                    SQLITE_LIKE_DOESNT_MATCH_BLOBS
                    SQLITE_MAX_EXPR_DEPTH=0
                    SQLITE_OMIT_DECLTYPE
                    SQLITE_OMIT_DEPRECATED
                    SQLITE_OMIT_PROGRESS_CALLBACK
                    SQLITE_OMIT_SHARED_CACHE
                    SQLITE_USE_ALLOCA
        )
        if(WITH_MILTER AND TARGET Threads::Threads)
            target_link_libraries(sqlite3 PRIVATE Threads::Threads)
        endif()
        add_library(sqlite3::sqlite3 ALIAS sqlite3)
        target_link_libraries(sqlite3 PUBLIC ${CMAKE_DL_LIBS})
    endif()
endif()

configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/src/postsrsd_build_config.h.in"
    "${CMAKE_CURRENT_BINARY_DIR}/postsrsd_build_config.h"
)

if(DEVELOPER_BUILD AND CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
    add_compile_options(-Wall -Wextra -Werror)
endif()

add_executable(
    postsrsd
    src/config.c
    src/database.c
    src/endpoint.c
    src/main.c
    src/milter.c
    src/netstring.c
    src/sha1.c
    src/srs.c
    src/srs2.c
    src/util.c
)

target_compile_definitions(postsrsd PRIVATE _GNU_SOURCE _FILE_OFFSET_BITS=64)
target_include_directories(postsrsd PRIVATE "${CMAKE_CURRENT_BINARY_DIR}")
target_compile_features(postsrsd PRIVATE c_std_99)
target_link_libraries(
    postsrsd
    PRIVATE Confuse::Confuse
            $<$<BOOL:${WITH_SQLITE}>:sqlite3::sqlite3>
            $<$<BOOL:${WITH_REDIS}>:${HIREDIS_TARGET}>
            $<$<BOOL:${WITH_MILTER}>:LibMilter::LibMilter>
            ${LIBSOCKET}
            ${LIBNSL}
)

configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/data/postsrsd.conf.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.conf" @ONLY
)
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/data/postsrsd.service.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.service" @ONLY
)
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/data/sysusers.conf.in"

=== tests/CMakeLists.txt ===
# PostSRSd - Sender Rewriting Scheme daemon for Postfix
# Copyright 2012-2022 Timo Röhling <timo@gaussglocke.de>
# SPDX-License-Identifier: GPL-3.0-only
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
add_subdirectory(unit)
add_subdirectory(blackbox)

=== tests/blackbox/CMakeLists.txt ===
# PostSRSd - Sender Rewriting Scheme daemon for Postfix
# Copyright 2012-2023 Timo Röhling <timo@gaussglocke.de>
# SPDX-License-Identifier: GPL-3.0-only
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
find_package(Python3 3.3 QUIET)

if(Python3_EXECUTABLE)
    add_test(
        NAME test_socketmap
        COMMAND
            "${Python3_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/socketmap.py"
            "$<TARGET_FILE:postsrsd>" "$<BOOL:${WITH_SQLITE}>"
    )
    if(WITH_MILTER)
        add_test(
            NAME test_milter
            COMMAND
                "${Python3_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/milter.py"
                "$<TARGET_FILE:postsrsd>"
        )
    endif()
endif()

=== tests/unit/CMakeLists.txt ===
# PostSRSd - Sender Rewriting Scheme daemon for Postfix
# Copyright 2012-2023 Timo Röhling <timo@gaussglocke.de>
# SPDX-License-Identifier: GPL-3.0-only
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
macro(add_postsrsd_test name)
    add_executable(${name}_executable ${name}.c ${ARGN})
    target_include_directories(
        ${name}_executable PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/src
    )
    target_compile_definitions(
        ${name}_executable PRIVATE _GNU_SOURCE _FILE_OFFSET_BITS=64
    )
    target_link_libraries(${name}_executable PRIVATE Check::check)
    target_compile_features(${name}_executable PRIVATE c_std_99)
    if(TESTS_WITH_ASAN)
        target_compile_options(
            ${name}_executable PRIVATE -fsanitize=address,undefined
        )
        target_link_options(
            ${name}_executable PRIVATE -fsanitize=address,undefined
        )
    endif()
    add_test(NAME ${name} COMMAND ${name}_executable)
endmacro()

set(SRCDIR ../../src)

add_postsrsd_test(test_netstring ${SRCDIR}/netstring.c)
add_postsrsd_test(test_sha1 ${SRCDIR}/sha1.c)
add_postsrsd_test(test_util ${SRCDIR}/util.c)
add_postsrsd_test(test_database ${SRCDIR}/database.c ${SRCDIR}/util.c)
target_link_libraries(
    test_database_executable PRIVATE $<$<BOOL:${WITH_SQLITE}>:sqlite3::sqlite3>
                                     $<$<BOOL:${WITH_REDIS}>:${HIREDIS_TARGET}>
)
add_postsrsd_test(test_srs2 ${SRCDIR}/srs2.c ${SRCDIR}/sha1.c)
add_postsrsd_test(
    test_config ${SRCDIR}/config.c ${SRCDIR}/sha1.c ${SRCDIR}/srs2.c
    ${SRCDIR}/util.c
)
target_link_libraries(test_config_executable PRIVATE Confuse::Confuse)

=== debian/changelog ===
postsrsd (2.0.11-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Abhijith PA ]
  * New upstream release.
  * Add myself as maintainer. (Closes: #1017361)
  * Update standards version to 4.7.2, no changes needed.
  * Add d/NEWS with migration information.
  * d/rules: Remove /lib dir created during build. usrmerge.
  * d/po/ca.po:Added po-debconf Catalan translation (Closes: #1106342)
    Thanks to Carles Pina i Estany <carles@pina.cat> for MR.
  * d/po/sv.po: Add·po-debconf·Swedish·translation  (Closes: #1072289)
    Thanks to Martin Bagge / brother <brother@persilja.net>
  * Add back postsrsd CHROOT_DIR in rules
  * Add python3 to build-depends to run optional blackbox tests.
  * Add d/install to move config file to /etc/default.
  * d/rules: remove build time generated /usr/lib/sysusers.d dir.

 -- Abhijith PA <abhijith@debian.org>  Mon, 01 Sep 2025 18:06:07 +0530

postsrsd (1.10-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * removed obsolete dependency on lsb-base

 -- Raju Devidas <mail@raju.dev>  Mon, 18 Mar 2024 14:39:24 +0530

=== debian/control ===
Source: postsrsd
Maintainer: Abhijith PA <abhijith@debian.org>
Section: mail
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-apparmor,
               faketime,
               check,
               libconfuse-dev,
               pkgconf,
               po-debconf,
               systemd-dev,
               python3
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/postsrsd
Vcs-Git: https://salsa.debian.org/debian/postsrsd.git
Homepage: https://github.com/roehling/postsrsd

Package: postsrsd
Architecture: any
Depends: adduser, debconf, ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Sender Rewriting Scheme (SRS) lookup table for Postfix
 PostSRSd provides Sender Rewriting Scheme (SRS) support for Postfix via
 TCP-based lookup tables. SRS is needed if your mail server acts as a forwarder,
 and the mail originates from a server with Sender Policy Framework (SPF)
 enabled.

=== debian/rules ===
#!/usr/bin/make -f

# export build flags
DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- -DCMAKE_BUILD_TYPE=Release -DGENERATE_SRS_SECRET=OFF -DPOSTSRSD_USER=postsrsd -DTESTS_WITH_ASAN=OFF -DCHROOT_DIR=/var/lib/postsrsd -DUSE_APPARMOR=ON -DFETCHCONTENT_TRY_FIND_PACKAGE_MODE=ALWAYS
override_dh_auto_test:
	dh_auto_test --buildsystem=cmake

override_dh_install:
	dh_install
	dh_apparmor --profile-name=usr.sbin.postsrsd
	install -m 0644 obj-$(DEB_HOST_GNU_TYPE)/postsrsd.conf debian/postsrsd/usr/share/postsrsd/postsrsd.template
	rm -rf $(CURDIR)/debian/postsrsd/usr/lib/sysusers.d/

override_dh_installinit:
	dh_installinit --restart-after-upgrade

=== debian/watch ===
version=4
opts="searchmode=plain,\
filenamemangle=s%.*/v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%" \
https://api.github.com/repos/roehling/postsrsd/releases?per_page=50 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@
